package me.lensfrex.littlebusters.api.v1.beans.responses;

import com.google.gson.annotations.SerializedName;

/**
 * 登录响应中data字段的对象
 */
public class LoginResponseData {
    /**
     * 登录用户的uid
     */
    private long uid;

    private String uuid;

    /**
     * 用户本次登录得到的token
     */
    @SerializedName("access_token")
    private String accessToken;

    /**
     * 用户此次得到的token的过期时间
     */
    @SerializedName("expired_at")
    private String expiredAt;

    public LoginResponseData(long uid, String uuid, String accessToken, String expiredAt) {
        this.uid = uid;
        this.uuid = uuid;
        this.accessToken = accessToken;
        this.expiredAt = expiredAt;
    }

    public long getUid() {
        return uid;
    }

    public void setUid(long uid) {
        this.uid = uid;
    }

    public String getUuid() {
        return uuid;
    }

    public void setUuid(String uuid) {
        this.uuid = uuid;
    }

    public String getAccessToken() {
        return accessToken;
    }

    public void setAccessToken(String accessToken) {
        this.accessToken = accessToken;
    }

    public String getExpiredAt() {
        return expiredAt;
    }

    public void setExpiredAt(String expiredAt) {
        this.expiredAt = expiredAt;
    }
}
