package me.lensfrex.littlebusters.api.v1.utils.jwt;

import io.jsonwebtoken.*;
import io.jsonwebtoken.security.Keys;
import io.jsonwebtoken.security.SignatureException;
import me.lensfrex.littlebusters.api.v1.utils.Time;

import java.security.Key;
import java.time.LocalDateTime;
import java.util.HashMap;
import java.util.Map;

public class JWTManager {
    // todo 时间有限先这样写能跑起来吧
    private final static Key key = Keys.secretKeyFor(SignatureAlgorithm.HS256);

    public String createNewJWT(String subject, String user, int invalidDays) {
        Map<String, Object> header = new HashMap<>();
        header.put("alg", "HS256");
        header.put("typ", "JWT");

        LocalDateTime now = Time.getNowDayTime();
        Map<String, Object> payload = new HashMap<>();
        payload.put("user", user);
        payload.put("start", now.toString());
        payload.put("exp", now.plusDays(invalidDays).toString());
        payload.put("api_ver", "1");
//        payload.put("iss", machineId);

        return Jwts.builder()
                .setHeader(header)
                .setClaims(payload)
                .signWith(key)
                .compact();

        // 这里生成token之后还是放在redis里边缓存一下吧
        // 但是考虑到各种因素就先不实现吧（懒）
    }

    public boolean verifyToken(String token) {
        try {
            Jws<Claims> jws =  Jwts.parserBuilder()
                    .setSigningKey(key)
                    .build()
                    .parseClaimsJws(token);

            System.out.println(jws);
        } catch (JwtException e) {
            System.err.println("Error: token is wrong: " + e.getMessage());
            return false;
        }

        return true;
    }
}
